PRINT N'Modificando [dbo].[BulkAbilityCognitive]...';


GO
ALTER PROCEDURE [dbo].[BulkAbilityCognitive]
AS
BEGIN
	SET NOCOUNT ON
	--select * from Dummy 
	--truncate table Dummy
	/*
	CREATE TABLE TMP_EVALUATIONPLANABILITY(
		VCC VARCHAR(50),
		ProcessId VARCHAR(50),
		EvaluationPlanId  VARCHAR(200),
		ID VARCHAR(250),
		Section  VARCHAR(50),
		Part VARCHAR(50),
		QueryId VARCHAR(50),
		TranscriptionId VARCHAR(200),
		NluId VARCHAR(50),
		IntentName VARCHAR(50),
		EndDate VARCHAR(50),
		Channel VARCHAR(50),
		Campaign VARCHAR(50)
	)
	*/

	/*insert into DummyEvaluationPlanAbility ([VCC]) values ('BULK')
	insert into TMP_EVALUATIONPLANABILITY ([VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[ID]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[TranscriptionId]
		  ,[NluId]
		  ,[IntentName]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign])  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[ID]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[TranscriptionId]
		  ,[NluId]
		  ,[IntentName]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
	  FROM [dbo].[#AbilityCognitiveTemp]
	*/  

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT ACTMP.[VCC],
							ACTMP.[EvaluationPlanId] 'EVALUATION_PLAN_ID'
						FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
						WHERE ACTMP.[VCC] IS NOT NULL 
							AND ACTMP.[EvaluationPlanId] IS NOT NULL

	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
		EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'
			
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	
	/* Script para actualizar a puntaje 100 la calificacion de cada habilidad retornada por luis */
	/*
	SELECT EP.[Description],
			ACTMP.[ID],
			I.[IntentId],
			I.[Name],
			A.[Title],
			AEP.Completed,
			ER.[Qualification],
			I.[AppId]
			*/

	UPDATE ER
		SET ER.[Qualification] = (AEF.[Score] * S.[Value]) / 100,
			ER.[OwnScore] = (AEF.[Score] * S.[Value]) / 100,
			ER.[ScoreDescription] = S.[Description],
			ER.[AbilityInnerScore] = S.[Value]
		FROM [#AbilityCognitiveTemp] ACTMP 
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[ID] = ACTMP.[EvaluationPlanId]
		INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
			ON AEF.[Instance] = EP.[Instance]
				AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				AND AEF.[IdAbility] = ACTMP.[AbilityId]
		INNER JOIN EvaluationResult ER (NOLOCK)
			ON ER.[Instance] = EP.[Instance] 
				AND ER.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				AND ER.[IdInteraction] = ACTMP.[ID]
		INNER JOIN [dbo].[Ability] A (NOLOCK) 
	       ON A.[Instance] = ER.[Instance] 
	            AND A.[ID] = ER.[IdAbility]
		INNER JOIN [dbo].[Score] S (NOLOCK)
			ON S.[IdAbility] = ACTMP.[AbilityId]
				AND S.[Value] = IIF(A.[IsNegative] = 1, 0, 100)
		WHERE AEF.[IdAbility] = ER.[IdAbility]
			AND ER.[IdAuditor] = 'SPEECH'
	
	/* Script para actualizar la tabla AuditorEvaluationPlan a Completed y Suma de Scores de la evaluacion */
	UPDATE AEP
		SET --AEP.[Completed] = '1',
			AEP.[Completed] = CASE WHEN AEPR.[Evaluation_Mode] = 'X' AND AEPR.[MinAutomaticQualification] <= AEPR.[SCORE] THEN '0' ELSE '1' END,
			AEP.[StatusDecription] = CASE WHEN AEPR.[Evaluation_Mode] = 'X' AND AEPR.[MinAutomaticQualification] <= AEPR.[SCORE] THEN 'NEW' ELSE 'COMPLETED' END,
			AEP.[Score] = AEPR.[SCORE],
			AEP.[AutomaticScore] = AEPR.[SCORE],
			-- AEP.[ManualScore] = AEPR.[SCORE], -- UNA EVALUACION AUTOMATICA DEBE TENER 0 DE MANUALSCORE
			AEP.[ManualScore] = 0,
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN (
			SELECT AEP.[Instance],
				AEP.[IdEvaluationPlan],
				AEP.[IdInteraction],
				EP.[Evaluation_Mode],
				EF.[MinAutomaticQualification],
				SUM(ER.[Qualification]) AS SCORE
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN EvaluationPlan EP (NOLOCK)
				ON EP.[Instance] = AEP.[Instance]
					AND EP.[ID] = AEP.[IdEvaluationPlan] 
			LEFT JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = AEP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			LEFT JOIN EvaluationResult ER (NOLOCK)
				ON ER.[Instance] = AEP.[Instance]
					AND ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND ER.[IdInteraction] = AEP.[IdInteraction]
			LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK) 
				ON AEF.[Instance] = EP.[Instance]
					AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			LEFT JOIN (SELECT DISTINCT ACTMP.[VCC],
									ACTMP.[EvaluationPlanId]
								FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
								WHERE ACTMP.[VCC] IS NOT NULL 
									AND ACTMP.[EvaluationPlanId] IS NOT NULL) TMP 
				ON TMP.[VCC] = AEP.[Instance]
					AND TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
			WHERE TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
				AND AEP.[IdAuditor] = 'SPEECH'
			GROUP BY AEP.[Instance], AEP.[IdEvaluationPlan], AEP.[IdInteraction], EP.[Evaluation_Mode], EF.[MinAutomaticQualification]
		) AEPR 
		ON AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
		WHERE AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
	
	;
	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[Qualification] = 0 AND AEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				AEF.[Penalizes],
				CASE AEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE AEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
				ON AEF.[Instance] = ER.[Instance] 
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp]) 
				AND ER.[Qualification] = 0 
				AND AEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				SUM(ER.[Qualification]) 'TOTAL_SCORE',
				SUM(ER.[Qualification] * CASE WHEN FP.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE'
		
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP
				ON FP.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP.[IdEvaluationPlan]
					AND CASE FP.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP.[PenalizedOn]
					AND FP.[Penalized] = 1
			--WHERE ER.[Instance] = 'multisalud'
			WHERE -- ER.[Instance] = FP.[Instance] -- ESTA LINEA CAUSA QUE NO SE ACTUALICEN LOS SCORES LAS EVALUACIONES QUE NO PENALIZAN
				-- AND 
				ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp])
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE],
			AEP.[AutomaticScore] = FS.[PENALIZED_SCORE],
			AEP.[ManualScore] = 0,
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP 
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
     --insert into test(origin,content) values('BulkAbilityCognitive',(select *  from [dbo].[#AbilityCognitiveTemp] FOR JSON AUTO))
	DROP TABLE [dbo].[#AbilityCognitiveTemp];
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkEvaluationPlanAbility]...';


GO
ALTER PROCEDURE [dbo].[BulkEvaluationPlanAbility]
AS
BEGIN
	SET NOCOUNT ON
	-- ESTE PROCEDURE RECIBE COMO RESULTADO LAS INTERACCIONES QUE COINCIDEN CON UN QUERY EN UN PLAN DE EVALUACION
	
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				EPATMP.[VCC]						'VCC', 
				EPATMP.[EvaluationPlanId]			'EVALUATION_PLAN_ID'
			FROM [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)

	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
		EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'

		-- INSERTAMOS LOS RESULTADOS DE LAS INTERACCIONES DE AUDIO QUE MATCHEARON CON LA QUERY
		INSERT INTO [dbo].[InteractionQueryResult] (
			[VCC],
			[InteractionId],
			[Section],
			[Part],
			[InteractionType],
			[TranscriptionId],
			[BatchType],
			[BatchTypeId],
			[BatchTypeName],
			[AnalysisType],
			[QueryId],
			[QueryName],
			[QueryValue],
			[QueryData],
			[Matches],
			[Details],
			[CreatedDate],
			[TimeStamp]
		)
			SELECT @CURRENT_VCC,
					PA.[AudioId],
					PA.[Section],
					PA.[Part],
					'CALL', --EPATMP.[Channel],
					CONCAT(PA.[AudioId], '_', ISNULL(PA.[Section], '0'), '_', ISNULL(PA.[Part], '0')),
					'EVALUATION_PLAN',
					@CURRENT_EVALUATION_PLAN_ID,
					EP.[Description],
					'SEMANTIC',
					GQ.[Name],
					GQ.[Name],
					GQ.[Query],
					GQ.[RawData],
					EPATMP.[Matches],
					EPATMP.[MatchesDetail],
					GETUTCDATE(),
					GETUTCDATE()
				FROM [#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = EPATMP.[VCC]
						AND EP.[ID] = EPATMP.[EvaluationPlanId]
				INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK)
					ON PA.[VCC] = EPATMP.[VCC]
						AND PA.[ProcessId] = EPATMP.[ProcessId]
						AND PA.[AudioId] = EPATMP.[AudioId]
						AND PA.[Section] = EPATMP.[Section]
						AND PA.[Part] = EPATMP.[Part]
				INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
					ON AEF.[Instance] = EPATMP.[VCC]
						AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				/*
				INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK)
					ON AQ.[VCC] = EPATMP.[VCC]
						AND AQ.[AbilityId] = AEF.[IdAbility] 
						AND AQ.[QueryId] = EPATMP.[QueryId]
				*/
				INNER JOIN [GenericQuery] GQ (NOLOCK)
					ON GQ.[VCC] = EPATMP.[VCC]
						AND GQ.[Name] = EPATMP.[QueryId]
				WHERE EPATMP.[VCC] = @CURRENT_VCC
					AND EPATMP.[EvaluationPlanId] = @CURRENT_EVALUATION_PLAN_ID

		-- INSERTAMOS LOS RESULTADOS DE LAS INTERACCIONES DE TEXTO QUE MATCHEARON CON LA QUERY
		INSERT INTO [dbo].[InteractionQueryResult] (
			[VCC],
			[InteractionId],
			[Section],
			[Part],
			[InteractionType],
			[TranscriptionId],
			[BatchType],
			[BatchTypeId],
			[BatchTypeName],
			[AnalysisType],
			[QueryId],
			[QueryName],
			[QueryValue],
			[QueryData],
			[Matches],
			[Details],
			[CreatedDate],
			[TimeStamp]
		)
			SELECT @CURRENT_VCC,
					PAI.[InteractionId],
					NULL,
					NULL,
					EPATMP.[Channel],
					EPATMP.[AudioId],
					'EVALUATION_PLAN',
					@CURRENT_EVALUATION_PLAN_ID,
					EP.[Description],
					'SEMANTIC',
					GQ.[Name],
					GQ.[Name],
					GQ.[Query],
					GQ.[RawData],
					EPATMP.[Matches],
					EPATMP.[MatchesDetail],
					GETUTCDATE(),
					GETUTCDATE()
				FROM [#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
				INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[Instance] = EPATMP.[VCC]
						AND EP.[ID] = EPATMP.[EvaluationPlanId]
				INNER JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
					ON PAI.[VCC] = EPATMP.[VCC]
						AND PAI.[ProcessId] = EPATMP.[ProcessId]
						AND PAI.[InteractionType] = EPATMP.[Channel]
						AND PAI.[FormattedEndDate] = EPATMP.[EndDate]
						AND PAI.[Campaign] = EPATMP.[Campaign]
						AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = EPATMP.[AudioId]
				INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
					ON AEF.[Instance] = EPATMP.[VCC]
						AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				/*
				INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK)
					ON AQ.[VCC] = EPATMP.[VCC]
						AND AQ.[AbilityId] = AEF.[IdAbility] 
						AND AQ.[QueryId] = EPATMP.[QueryId]
				*/
				INNER JOIN [GenericQuery] GQ (NOLOCK)
					ON GQ.[VCC] = EPATMP.[VCC]
						AND GQ.[Name] = EPATMP.[QueryId]
				WHERE EPATMP.[VCC] = @CURRENT_VCC
					AND EPATMP.[EvaluationPlanId] = @CURRENT_EVALUATION_PLAN_ID
		
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS

	
	
	
	--ACTUALIZAR LOS SCORES DE LAS HABILIDADES RETORNADAS EN LA TABLA TEMPORAL
	UPDATE ER 
	SET ER.[Qualification] = (S.[Value] * AEF.[Score] / 100), 
		ER.[OwnScore] = (AEF.[Score] * S.[Value]) / 100,
		ER.[ScoreDescription] = S.[Description],
		ER.[AbilityInnerScore] = S.[Value]
	FROM [dbo].[EvaluationResult] ER (NOLOCK)
	INNER JOIN [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
	--INNER JOIN [dbo].[DummyEvaluationPlanAbility] EPATMP (NOLOCK)
		ON ER.[Instance] = EPATMP.[VCC]
		AND ER.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		AND ER.[IdInteraction] = EPATMP.[AudioId] 
	LEFT JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
		ON AEF.[Instance] = ER.[Instance] 
		AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
		AND AEF.[IdAbility] = ER.[IdAbility]
	INNER JOIN [dbo].[Ability] A (NOLOCK) 
		ON A.[Instance] = ER.[Instance] 
		AND A.[ID] = ER.[IdAbility]
	INNER JOIN [dbo].[AbilityQuery] AB (NOLOCK)
		ON AB.[VCC] = ER.[Instance] 
			AND AB.[AbilityId] = AEF.[IdAbility]
			AND AB.[QueryId] = EPATMP.[QueryId]
	LEFT JOIN [dbo].[Score] S (NOLOCK) 
		ON S.[Instance] = ER.[Instance] 
		AND S.[IdAbility] = ER.[IdAbility]
		AND S.[Value] =  IIF(A.[IsNegative] = 1, 0, 100);

	WITH 
	-- DECLARAMOS UNA CTE PARA DEPOSITAR LOS RESULTADOS DE LA SUMA DE HABILIDADES PARA LA EVALUACION
	CteEvaluationScoreResult AS (
		-- ESTE BLOQUE ACTUALIZA LAS NOTAS DE EVALUACIONES AUTOMATICAS SEGUN LOS PLANES CONTENIDOS EN LA TEMPORAL
		SELECT ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction], SUM(ER.[Qualification]) TOTAL
			FROM EvaluationResult ER 
			INNER JOIN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) EPATMP 
			--INNER JOIN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility) EPATMP 
				ON EPATMP.[EvaluationPlanId] = ER.[IdEvaluationPlan] 
			LEFT JOIN AbilityEvaluationFormat AEF 
				ON AEF.[Instance] = ER.[Instance]
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
					AND AEF.[ID] = ER.[IdAbilityEvaluationFormat]
			WHERE ER.[IdAuditor] = 'SPEECH'
			GROUP BY ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction]
	)
	
	-- SE ACTUALIZA LAS EVALUACIONES QUE COINCIDEN CON LOS RESULTADOS
	UPDATE AEP 
		SET AEP.[Score] = ESR.[TOTAL],
			AEP.[AutomaticScore] =  ESR.[TOTAL],
			AEP.[ManualScore] = 0,
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		INNER JOIN CteEvaluationScoreResult ESR 
			ON AEP.[Instance] = ESR.[Instance]
				AND AEP.[IdEvaluationPlan] = ESR.[IdEvaluationPlan]
				AND AEP.[IdAuditor] = ESR.[IdEvaluator]
				AND AEP.[IdInteraction] = ESR.[IdInteraction]

	;
	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[Qualification] = 0 AND AEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				AEF.[Penalizes],
				CASE AEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE AEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
				ON AEF.[Instance] = ER.[Instance] 
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) 
			--WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility) 
				AND ER.[Qualification] = 0 
				AND AEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),
	--SELECT * FROM CTEFP

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				SUM(ER.[Qualification]) 'TOTAL_SCORE',
				--SUM(ER.[Qualification] * CASE WHEN FP2.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE',
				SUM(ER.[Qualification] * (
					CASE WHEN (
						CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1) THEN 0 ELSE 1 END
				)) 'PENALIZED_SCORE'
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[IdInteraction], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP2
				ON FP2.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP2.[IdEvaluationPlan]
					AND ER.[IdInteraction] = FP2.[IdInteraction]
					/*
					AND CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
					AND FP2.[Penalized] = 1
					*/
			--WHERE ER.[Instance] = 'multisalud'
			WHERE -- ER.[Instance] = FP2.[Instance] -- ESTA LINEA CAUSA QUE NO SE ACTUALICEN LOS SCORES LAS EVALUACIONES QUE NO PENALIZAN
				-- AND 
				ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp)
				--AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility)
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE],
			AEP.[AutomaticScore] = FS.[PENALIZED_SCORE],
			AEP.[ManualScore] = 0,
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
	--insert into test(origin,content) values('BulkAbilityCognitive',(select *  from [dbo].[#AbilityCognitiveTemp] FOR JSON AUTO))

	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE [dbo].[#EvaluationPlanAbilityTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkProcessInteraction]...';


GO

ALTER PROCEDURE [dbo].[BulkProcessInteraction]
AS
BEGIN
	/*
	-- ACTUALIZAMOS LOS AUDIOS CON EL RESULTADO EN LA TABLA
	UPDATE [dbo].[Audio] SET
		[dbo].[Audio].[Format] = [dbo].[#ProcessInteractionTemp].[Format],
		[dbo].[Audio].[MediaInfoTime] = [dbo].[#ProcessInteractionTemp].[MediaInfoTime],
		[dbo].[Audio].[DurationLinguisticTime] = [dbo].[#ProcessInteractionTemp].[DurationLinguisticTime],
		[dbo].[Audio].[IsDiariced] = [dbo].[#ProcessInteractionTemp].[IsDiariced],
		[dbo].[Audio].[ChannelsChanged] = [dbo].[#ProcessInteractionTemp].[ChannelsChanged],
		[dbo].[Audio].[ValidChar] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidChar], [dbo].[Audio].[ValidChar]),
		[dbo].[Audio].[ValidWords] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidWords], [dbo].[Audio].[ValidWords]),
		[dbo].[Audio].[TotalPhrases] = [dbo].[#ProcessInteractionTemp].[TotalPhrases],
		[dbo].[Audio].[CharsPerPhrase] = [dbo].[#ProcessInteractionTemp].[CharsPerPhrase],
		[dbo].[Audio].[IsTranscribed] = [dbo].[#ProcessInteractionTemp].[IsTranscribed],
		[dbo].[Audio].[IsCancel] = [dbo].[#ProcessInteractionTemp].[IsCancel],
		[dbo].[Audio].[FileName] = [dbo].[#ProcessInteractionTemp].[FileName],
		[dbo].[Audio].[ErrorMessage] = [dbo].[#ProcessInteractionTemp].[ErrorMessage],
		[dbo].[Audio].[LastModifiedDate] = GETUTCDATE()
	FROM [dbo].[#ProcessInteractionTemp]
	WHERE
		[dbo].[Audio].[VCC] = [dbo].[#ProcessInteractionTemp].[VCC]
		AND [dbo].[Audio].[ID] = [dbo].[#ProcessInteractionTemp].[ID]
		AND [dbo].[Audio].[Section] = [dbo].[#ProcessInteractionTemp].[Section]
		AND [dbo].[Audio].[Part] = [dbo].[#ProcessInteractionTemp].[Part]
		AND [dbo].[#ProcessInteractionTemp].[Channel] = 'CALL'
	*/

	-- ACTUALIZAMOS LOS AUDIOS CON EL RESULTADO EN LA TABLA
	UPDATE A
		SET A.[Format] = PIT.[Format],
			A.[MediaInfoTime] = PIT.[MediaInfoTime],
			A.[DurationLinguisticTime] = PIT.[DurationLinguisticTime],
			A.[IsDiariced] = PIT.[IsDiariced],
			A.[ChannelsChanged] = PIT.[ChannelsChanged],
			A.[ValidChar] = ISNULL(PIT.[ValidChar], [dbo].[Audio].[ValidChar]),
			A.[ValidWords] = ISNULL(PIT.[ValidWords], [dbo].[Audio].[ValidWords]),
			A.[TotalPhrases] = PIT.[TotalPhrases],
			A.[CharsPerPhrase] = PIT.[CharsPerPhrase],
			A.[IsTranscribed] = PIT.[IsTranscribed],
			A.[IsCancel] = PIT.[IsCancel],
			A.[FileName] = PIT.[FileName],
			A.[ErrorMessage] = PIT.[ErrorMessage],
			A.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Audio] A
		INNER JOIN [dbo].[#ProcessInteractionTemp] PIT
			ON PIT.[VCC] = PIT.[VCC]
				AND A.[ID] = PIT.[ID]
				AND A.[Section] = PIT.[Section]
				AND A.[Part] = PIT.[Part]
		WHERE PIT.[Channel] = 'CALL'

	-- ACTUALIZAMOS LOS TEXT CON EL RESULTADO DE LA TABLA
	UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[ValidChar] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidChar], [dbo].[AsyncInteraction].[ValidChar]),
			[dbo].[AsyncInteraction].[ValidWords] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidWords], [dbo].[AsyncInteraction].[ValidWords]),
			[dbo].[AsyncInteraction].[TotalPhrases] = [dbo].[#ProcessInteractionTemp].[TotalPhrases],
			[dbo].[AsyncInteraction].[CharsPerPhrase] = [dbo].[#ProcessInteractionTemp].[CharsPerPhrase],
			[dbo].[AsyncInteraction].[IsTranscribed] = [dbo].[#ProcessInteractionTemp].[IsTranscribed],
			[dbo].[AsyncInteraction].[IsCancel] = [dbo].[#ProcessInteractionTemp].[IsCancel],
			[dbo].[AsyncInteraction].[FileName] = [dbo].[#ProcessInteractionTemp].[FileName],
			[dbo].[AsyncInteraction].[ViewFileName] = [dbo].[#ProcessInteractionTemp].[ViewFileName],
			[dbo].[AsyncInteraction].[ErrorMessage] = [dbo].[#ProcessInteractionTemp].[ErrorMessage],
			[dbo].[AsyncInteraction].[LastModifiedDate] = GETUTCDATE()
	FROM [dbo].[#ProcessInteractionTemp]
	WHERE [dbo].[AsyncInteraction].[VCC] = [dbo].[#ProcessInteractionTemp].[VCC]
		AND [dbo].[AsyncInteraction].[Campaign] = [dbo].[#ProcessInteractionTemp].[Campaign]
		AND [dbo].[AsyncInteraction].[Channel] = [dbo].[#ProcessInteractionTemp].[Channel]
		AND [dbo].[AsyncInteraction].[ID] = [dbo].[#ProcessInteractionTemp].[ID]
		AND [dbo].[AsyncInteraction].[Folder] = [dbo].[#ProcessInteractionTemp].[Folder]

	DROP TABLE [dbo].[#ProcessInteractionTemp]
END
GO
PRINT N'Modificando [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN

	INSERT INTO [Progress] ([Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription])  
	SELECT [Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription]
	  FROM [dbo].[#ProgressTemp]

	-----------ESTADOS DE PROCESS I6UPDATE-----------

	-- ACTUALIZAMOS EL ESTADO GENERAL DE PROCESS SOBRE LA ACTUALIZACION DE INTERACCIONES CALL I6
	UPDATE P 
		SET [Total] = PT.[Total]
			,[progress] = PT.[Progress]
			,[error] = PT.[Error]
			,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 AND PT.[Percentage] = 1 AND  ISNULL(PT.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN PT.[Total] >= 0 AND PT.[Percentage] = 1 AND  ISNULL(PT.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON P.[vcc] = PT.[vcc] 
				AND PT.ProcessId = P.[Name] 
		WHERE PT.[Type] = 'i6update'

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
	UPDATE A
		SET [Status] = CASE 
				WHEN B.total >= 0 AND B.total <= B.[updated] + B.cancel AND B.cancel > B.[updated] THEN 'FAILED' 
				WHEN B.total >= 0 AND B.total <= B.[updated] + B.cancel THEN 'COMPLETE' 
				ELSE 'INPROCESS_I6_UPDATE' 
				END
			,[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] AS A
		INNER JOIN (
			SELECT SUM(UT.total)									'total',
					SUM(UT.cancel)									'cancel',
					SUM(UT.[updated])								'updated',
					UT.processId									'processId',
					UT.vcc											'vcc'
				FROM (
					SELECT COUNT(1)										'total'
							,COUNT(A.[isCancel])						'cancel'
							,COUNT(IIF(A.[NeedI6Update] = 0, 1, 0))		'updated' 
							,PT.[ProcessId]								'processId'
							,PT.[vcc]									'vcc'
						FROM [dbo].[ProcessAudio] PA (NOLOCK)
						INNER JOIN [#ProgressTemp] PT 
							ON PA.[vcc] = PT.[vcc] 
								AND PA.ProcessId = PT.ProcessId 
								AND PT.[Percentage] = 1
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON PA.[VCC] = A.VCC 
								AND PA.[AudioId] = A.ID 
						WHERE PT.[Type] = 'i6update'
						GROUP BY PT.ProcessId, PT.vcc
				) UT 
				GROUP BY UT.processId, UT.vcc
		) B ON A.[vcc] = B.[vcc] 
			AND A.[Name] = B.[ProcessId]
	  
	------------Estados de procesos --------------
	UPDATE A
		SET [Total] = PT.[Total]
			,[progress] = PT.[Progress]
			,[error] = PT.[Error]
			,[percentage] = CASE WHEN PT.[Total] > 0 THEN PT.[Percentage] ELSE 0 END
			,[StatusDescription] = CASE WHEN PT.[Total] >= 0 AND PT.[Percentage] = 1 AND  ISNULL(PT.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN PT.[Total] >= 0 AND PT.[Percentage] = 1 AND  ISNULL(PT.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[LastModifiedDate] = GETUTCDATE()
		FROM Process AS A
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON A.[vcc] = PT.[vcc] 
				AND A.[Name] = PT.ProcessId 
		WHERE PT.[Type] IS NULL

	-- ACTUALIZAMOS EL ESTADO DEL PROCESS TERMINADO
	UPDATE A
	SET [Status] = CASE 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED' 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE' 
			ELSE 'INPROCESS_TRANSCRIPTION' 
			END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN (
		SELECT SUM(UT.total)					'total',
				SUM(UT.cancel)					'cancel',
				SUM(UT.transcription)			'transcription',
				UT.processId					'processId',
				UT.vcc							'vcc'
			FROM (
			SELECT COUNT(1)					total
					,COUNT(C.isCancel)			cancel
					,COUNT(C.IsTranscribed)		transcription 
					,B.ProcessId				processId
					,B.vcc						vcc
				FROM [ProcessAudio] A (NOLOCK)
				INNER JOIN [#ProgressTemp] B 
					ON A.[vcc] = B.[vcc] 
						AND A.ProcessId = B.ProcessId 
						-- AND B.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN Audio C (NOLOCK) 
					ON A.VCC = C.VCC 
						AND A.AudioId =C.ID 
						AND ISNULL(A.Section,0) = ISNULL(C.Section,0) 
						AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
				WHERE B.[Type] IS NULL
				GROUP BY B.ProcessId, B.vcc
			UNION
			SELECT 
				COUNT(1)						total
				,COUNT(AI.IsCancel)			cancel
				,COUNT(AI.IsTranscribed)		transcription
				,PT.[ProcessId]				processId
				,PT.[vcc]						vcc
				FROM [ProcessAsyncInteraction] PAI (NOLOCK)
				INNER JOIN [#ProgressTemp] PT
					ON PAI.[VCC] = PT.[vcc]
						AND PAI.[ProcessId] = PT.[ProcessId]
						-- AND PT.[Percentage] = 1 -- ESTA LINEA NO PERMITE ACTUALIZAR LA COLUMNA STATUS CUANDO EL PROCESS AUN NO TERMINA
				INNER JOIN [AsyncInteraction] AI (NOLOCK) 
					ON AI.[VCC] = PT.[vcc]
						AND AI.[Channel] = PAI.[InteractionType]
						AND AI.[Folder] = PAI.[FormattedEndDate]
						AND AI.[Campaign] = PAI.[Campaign]
						AND AI.[ID] = PAI.[InteractionId]
				WHERE PT.[Type] IS NULL
				GROUP BY PT.ProcessId, PT.vcc
		) UT GROUP BY UT.processId, UT.vcc

	  ) B ON A.[vcc] = B.[vcc] 
		AND A.[Name] = B.ProcessId

	-- ACTUALIZAMOS EL ESTADO DE OTROS PROCESOS QUE ESTAN COMO FALLIDOS, COLGADOS, ETC QUE COINCIDEN CON LAS INTERACCIONES DEL PROCESS TERMINADO
	UPDATE P
		SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
								ELSE 'COMPLETE' END,
			P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR' 
											ELSE 'COMPLETED' END,
			P.[Percentage] = 1
			,P.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT UT.[processId]							'processId',
					ISNULL(SUM(UT.[totalAudio]), 0)			'totalAudio',
					ISNULL(SUM(UT.[totalSucced]), 0)		'totalSucced',
					ISNULL(SUM(UT.[totalFailed]), 0)		'totalFailed'
				FROM (
					SELECT P.[Name] 'processId',
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
							ON PA.[VCC] = P.[VCC]
								AND PA.[ProcessId] = P.[Name]
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON A.[VCC] = PA.[VCC]
								AND A.[ID] = PA.[AudioId]
								AND A.[Section] = PA.[Section]
								AND A.[Part] = PA.[Part]
						WHERE 
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR 
							(P.[Total] = 0 AND P.[Percentage] = 0)
							-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
							--AND P.[StatusDescription] = 'IN_PROGRESS'
						GROUP BY P.[Name]
			
					UNION

					SELECT P.[Name],
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
							ON PAI.[VCC] = P.[vcc]
								AND PAI.[ProcessId] = P.[Name]
						INNER JOIN [AsyncInteraction] AI (NOLOCK) 
							ON AI.[VCC] = P.[vcc]
								AND AI.[Channel] = PAI.[InteractionType]
								AND AI.[Folder] = PAI.[FormattedEndDate]
								AND AI.[Campaign] = PAI.[Campaign]
								AND AI.[ID] = PAI.[InteractionId]
						WHERE 
							(P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR 
							(P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR 
							(P.[Total] = 0 AND P.[Percentage] = 0)
						GROUP BY P.[Name]
					) UT GROUP BY UT.[processId]
		) TMPP
			ON TMPP.[processId] = P.[Name]
				AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	-- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Process] P 
				ON P.[vcc] = PTMP.[vcc] 
					AND P.[Name] = PTMP.[ProcessId] 
					AND PTMP.[Type] IS NULL
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL
	
	------------ESTADOS DE ESTUDIOS --------------
	UPDATE A
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			,[LastModifiedDate] = GETUTCDATE()
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.[ProcessId] = B.ProcessId 
				AND A.[Name] = B.[TypeId] 
				AND B.[Type] = 'study'
				
	--Eliminar StudyResultSummary
	         DELETE SRS FROM [dbo].[StudyResultSummary] SRS 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SRS.[VCC] 
	                       AND S.[Name] = SRS.[StudyId] 
	                       AND S.[TemplateId] = SRS.[TemplateId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRS.[TemplateThemeId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.ProcessId 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type] = 'study')
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SRS.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)
	                  
	           	        
	 -- Eliminar StudyResultSummaryDetail     	        
	           	        
	           	  DELETE SRSD FROM [dbo].[StudyResultSummaryDetail] SRSD 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SRSD.[VCC] 
	                       AND S.[Name] = SRSD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SRSD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI 
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SRSD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.ProcessId 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type] = 'study')
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SRSD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)
	
   	 -- Eliminar StudyResultSummaryDetail     	        
	           	        
	           	  DELETE SD FROM [dbo].[StudyDetail] SD 
	                    JOIN [dbo].[Study]  S 
	                         ON 
	                        (S.[VCC] = SD.[VCC] 
	                       AND S.[Name] = SD.[StudyId])
	                   JOIN [dbo].[TemplateTheme] TT
	                         ON 
	                           (TT.[VCC] = S.[VCC]
	                            AND TT.[TemplateId] = S.[TemplateId]
	                            AND TT.[ID] = SD.[TemplateThemeId])
	                   JOIN [dbo].[TemplateThemeItem] TTI 
	                          ON (TTI.[VCC] = S.[VCC]
	                              AND TTI.[TemplateThemeId] = TT.[ID]
	                              AND TTI.[ID] = SD.[TemplateThemeItemId])
	                   JOIN [dbo].[#ProgressTemp] PT 
	                        ON  
	                       (S.[VCC] = PT.[vcc] 
							AND S.[ProcessId] = PT.[ProcessId] 
							AND S.[Name] = PT.[TypeId] 
							AND PT.[Type] = 'study')
						--Si es negativo eliminar los que IsMatched = 1 
	                   WHERE SD.[IsMatched] = IIF(TT.[IsNegative] = 1, 1, 0)
	                   
	                   
	                   
	                   
	              

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'STUDY', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Study] S 
				ON S.[vcc] = PTMP.[vcc] 
					AND S.[ProcessId] = PTMP.[ProcessId] 
					AND S.[Name] = PTMP.[TypeId]
					AND PTMP.[Type] = 'study'
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] = 'study'

	------------Estados de plan de evaluacion --------------

	-- UPDATE PARA LA PARTE DE TRANSCRIPCION
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE 'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND B.[Type] IS NULL 
			AND A.[FilterByContentQueryName] IS NOT NULL 
			AND A.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'evaluationPlan'

	-- UPDATE PARA LA PARTE DE ANALISIS SEMANTICO/COGNITIVO
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B ON A.[Instance] = B.[vcc] 
	AND A.[ProcessId] = B.ProcessId 
	AND B.[Type] IS NULL 
	AND A.[FilterByContentQueryName] IS NULL 
	AND A.[FilterByContentQuery] IS NULL 
	AND (
		A.[Evaluation_Mode] = 'A' 
		OR
		A.[Evaluation_Mode] = 'X'
	)

	-- ACTUALIZAMOS EL ESTADO DE LOS PLANES DE LA TABLA TEMPORAL
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 7 ELSE 6 END
		,[LastModifiedDate] = GETUTCDATE() 
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'ability'

	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 7 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
	UPDATE AEP 
		SET AEP.[Completed] = 1
			,[StatusDescription] = 'COMPLETED'
			,[LastModifiedDate] = GETUTCDATE()
	FROM dbo.[AuditorEvaluationPlan] AEP 
	INNER JOIN dbo.[EvaluationPlan] EP 
		ON EP.[ID] = AEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON EP.[Instance] = B.[vcc] 
			AND EP.[ProcessId] = B.ProcessId 
			AND EP.Id = B.[TypeId] 
			AND B.[Type] = 'ability'
	WHERE EP.[Status] = 7
		AND AEP.[IdAuditor] = 'SPEECH' 
		AND (EP.[Evaluation_Mode] = 'A' OR EP.[Evaluation_Mode] = 'X') 

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')

	-- INICIO MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT PTMP.[vcc] 'VCC', 
				PTMP.[TypeId] 'EVALUATION_PLAN_ID'
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			
	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION NUMERIC(5, 2) = 0

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- BUSCAMOS SI EXISTE RESULTS PARA EL PLAN ACTUAL
		IF NOT EXISTS (
			SELECT 1 
				FROM [dbo].[EvaluationResult] ER (NOLOCK) 
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		)
		BEGIN
			-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
			EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'

			-- ACTUALIZAMOS A COMPLETED LOS REGISTROS AUDITOR_EVALUATION_PLAN DEL PLAN ACTUAL
			UPDATE AEP
				SET AEP.[Completed] = '1'
					,AEP.[StatusDescription] = 'COMPLETED'
					,AEP.[LastModifiedDate] = GETUTCDATE()
				FROM AuditorEvaluationPlan AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		END

		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS





	-- INICIO DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS(TERMINADA LA FASE AUTOMATICA(ESTADO 7), PASA A LA MANUAL(ESTADO 8) Y ACABADA LA MANUAL REGRESA AL ESTADO 7)

	DECLARE @CURRENT_AUDITOR_ID VARCHAR(50) = ''

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR_2 CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				PT.[vcc]								'VCC', 
				PT.[TypeId]								'EVALUATION_PLAN_ID',
				EF.[MinAutomaticQualification]			'MIN_AUTOMATIC_QUALIFICATION'
			FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
			INNER JOIN [dbo].[#ProgressTemp] PT 
				ON EP.[Instance] = PT.[vcc] 
					AND EP.[ProcessId] = PT.[ProcessId] 
					AND EP.[Id] = PT.[TypeId] 
					AND PT.[Type] = 'ability'
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = EP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			WHERE EP.[Status] = 7
				AND EP.[Evaluation_Mode] = 'X'

	-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
	OPEN MY_CURSOR_2
	FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EVALUAMOS SI EL AUDITOR SPEECH CALIFICO CON NOTA MAYOR O IGUAL AL ACEPTABLE MINIMO PARA LA PARTE AUTOMATICA
		IF EXISTS (
			SELECT 1
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND AEP.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
		)
		BEGIN
			-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
			UPDATE EP 
				SET EP.[percentage] = 0
					,EP.[StatusDescription] = 'IN_PROGRESS'
					,EP.[Status] = 8
					,EP.[LastModifiedDate] = GETUTCDATE() 
				FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
				WHERE EP.[Instance] = @CURRENT_VCC
					AND EP.[ID] = @CURRENT_EVALUATION_PLAN_ID

			-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS ID DE AUDITORES CORRESPONDIENTES AL PLAN
			DECLARE MY_AUDITOR_CURSOR CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
				FOR 
				-- CONSULTAMOS LOS ID DE AUDITORES
				SELECT DISTINCT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE  AEP.[Instance] = @CURRENT_VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND AEP.[IdAuditor] <> 'SPEECH'

			-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
			OPEN MY_AUDITOR_CURSOR
			FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- INSERTARMOS LOS REGISTROS DE ER QUE TENIA EL AUDITOR SPEECH
				INSERT INTO [dbo].[EvaluationResult] (
					[Instance], [IdCampaign], [IdInteraction], [IdAgent], [IdEvaluationFormat],
					[MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification],
					[IdEvaluator], [EvaluationDate], [MaxAbilityScore], [IdEvaluationPlan], [CreatedDate],
					[CreatedByUserId], [TimeStamp], [NotApplies], [ScoreDescription], [CampaignDescription],
					[AgentDescription], [InteractionDateini], [InteractionDatefin], [InteractionAddress], [AbilityOrder],
					[InteractionType], [IdAbilityEvaluationFormat], [IdAuditor], [Conditional]
				) 
					-- SELECCIONAMOS LOS RESULTADOS REGISTRADOS POR SPEECH
					SELECT ER.[Instance], ER.[IdCampaign], ER.[IdInteraction], ER.[IdAgent], ER.[IdEvaluationFormat],
							ER.[MinQualificationAcceptable], ER.[IdGroup], ER.[IdSubGroup], ER.[IdAbility], ER.[Qualification],
							ER.[IdEvaluator], ER.[EvaluationDate], ER.[MaxAbilityScore], ER.[IdEvaluationPlan], ER.[CreatedDate],
							ER.[CreatedByUserId], GETUTCDATE(), ER.[NotApplies], ER.[ScoreDescription], ER.[CampaignDescription],
							ER.[AgentDescription], ER.[InteractionDateini], ER.[InteractionDatefin], ER.[InteractionAddress], ER.[AbilityOrder],
							ER.[InteractionType], ER.[IdAbilityEvaluationFormat], @CURRENT_AUDITOR_ID, ER.[Conditional]
						FROM [dbo].[EvaluationResult] ER (NOLOCK)
						INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
							ON AEP.[Instance] = ER.[Instance]
								AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
								AND AEP.[IdAuditor] = ER.[IdAuditor]
								AND AEP.[IdInteraction] = ER.[IdInteraction]
								AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
						WHERE ER.[Instance] = @CURRENT_VCC
							AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
							AND ER.[IdAuditor] = 'SPEECH'

				-- REABRIMOS LAS EVALUACIONES DE LAS INTERACCIONES CON SCORE MAYOR O IGUAL AL UMBRAL
				UPDATE [dbo].[AuditorEvaluationPlan]
					SET [Completed] = 0,
						[AutomaticScore] = [Score],
						[ManualScore] = 0,
						[StatusDescription] = 'NEW',
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = @CURRENT_AUDITOR_ID

				FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			END
			CLOSE MY_AUDITOR_CURSOR
			DEALLOCATE MY_AUDITOR_CURSOR

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

			-- REMOVEMOS LOS REGISTROS DE SPEECH (AEP Y ER) QUE FUERON ASIGNADOS A LOS AUDITORES
			DELETE ER
				FROM [dbo].[EvaluationResult] ER
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON AEP.[Instance] = ER.[Instance]
						AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
						AND AEP.[IdInteraction] = ER.[IdInteraction]
						AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND ER.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE SPEECH EN AEP QUE PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] = 'SPEECH'
					AND [Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE LOS OTROS AUDITORES QUE NO PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'
					AND [IdInteraction] IN (
						SELECT [IdInteraction] 
							FROM [dbo].[AuditorEvaluationPlan] 
							WHERE [Instance] = @CURRENT_VCC
								AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
								AND [IdAuditor] = 'SPEECH'
								AND [Score] < @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
					)

			-- ACTUALIZAMOS LOS CAMPOS SCORE DE LAS EVALUACIONES DE SPEECH
			UPDATE [dbo].[AuditorEvaluationPlan]
					SET [AutomaticScore] = [Score],
						[ManualScore] = 0,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = 'SPEECH'

		END
		ELSE
		BEGIN
			-- ELIMINAMOS LOS REGISTROS DE LOS OTROS AUDITORES (AEP)
			DELETE FROM [dbo].[AuditorEvaluationPlan] 
				WHERE  [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

		END

		FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	END
	CLOSE MY_CURSOR_2
	DEALLOCATE MY_CURSOR_2

	-- INVALIDAR LAS AUDITORIAS CUYO AUDIO PRESENTAN ALGUN ERROR
	UPDATE AEP
		SET AEP.[StatusDescription] = 'INVALID'
		FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
		JOIN [dbo].[Audio] A (NOLOCK)
		    ON AEP.[Instance] = A.[VCC] 
		        AND AEP.[IdInteraction] = A.[ID]
		JOIN [#ProgressTemp] PTMP (NOLOCK)
			ON AEP.[Instance] = PTMP.[vcc]
			    AND AEP.[IdEvaluationPlan] = PTMP.[TypeId]
		WHERE (A.[IsTranscribed] IS NULL OR A.[IsTranscribed]  <> 1)
		    AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')        
		    -- AND A.[ErrorMessage] IN ('GET_AUDIO_REQUEST_FAILED','JSON_IDATHA_IS_NOT_FOUND','JSON_TRANSCRIPTION_CONTENT_IS_EMPTY')

	-- RECUPERAMOS LAS EVALUACIONES DE SPEECH DE LA TABLA AUDITOR EVALUATION PARA REPLICARLA

	/*
	-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
	UPDATE EP 
		SET EP.[percentage] = 0
			,EP.[StatusDescription] = 'IN_PROGRESS'
			,EP.[Status] = 8
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON EP.[Instance] = PT.[vcc] 
				AND EP.[ProcessId] = PT.[ProcessId] 
				AND EP.[Id] = PT.[TypeId] 
				AND PT.[Type] = 'ability'
		WHERE EP.[Status] = 7
			AND EP.[Evaluation_Mode] = 'X'
	*/
	

	-- FIN DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS





	-----------------------------------------------------

	DROP TABLE [dbo].[#ProgressTemp]

END
GO
PRINT N'Modificando [dbo].[GetI6InteractionAudios]...';


GO
ALTER PROCEDURE [dbo].[GetI6InteractionAudios] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL
) AS 
BEGIN
	-- DECLARAMOS VARIABLES PARA ALMACENAR LAS CANTIDADES DE REGISTROS
	DECLARE @AUDIO_RECORDS INT = 0
	DECLARE @INTERACION_EVALUATION_PLAN_RECORDS INT = 0

	SELECT @AUDIO_RECORDS = COUNT(*)
		FROM [dbo].[Audio] A (NOLOCK)
		WHERE A.[VCC] = @VCC
			AND A.[ID] = @InteractionId

	SELECT @INTERACION_EVALUATION_PLAN_RECORDS = COUNT(DISTINCT CONCAT(IEP.[IdInteraction], '_', IEP.[InteractionSection], '_', IEP.[InteractionPart]))
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		WHERE IEP.[Instance] = @VCC	
			AND IEP.[IdInteraction] = @InteractionId

	IF @AUDIO_RECORDS >= @INTERACION_EVALUATION_PLAN_RECORDS
	BEGIN

		-- BUSCAMOS LOS AUDIOS DE LA INTERACCION
		SELECT [ID]									'id',
				[Section]							'section',
				[Part]								'part',
				[Agent]								'agent',
				[Format]							'format'
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[ID] = @InteractionId
			ORDER BY A.[Section] ASC,  A.[Part] ASC
	END
	ELSE
	BEGIN
		SELECT [IdInteraction]						'id',
				[InteractionSection]				'section',
				[InteractionPart]					'part',
				[IdAgent]							'agent',
				[InteractionFormat]					'format'
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @VCC	
				AND IEP.[IdInteraction] = @InteractionId
			ORDER by IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC
	END
END
GO
PRINT N'Modificando [dbo].[GetI6SyncInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetI6SyncInteractions]
(
	@VCC					VARCHAR(50) = NULL,
	@IP						VARCHAR(50),						-- IP DEL SERVIDOR PARA LA BASE I6
	@Type					INT,								-- FLAG PARA INDICAR SI EL SERVIDOR I6 SE ENCUENTRA LOCAL O REMOTO
	@InteractionType		VARCHAR(50) = NULL,
	@StartDate				DATETIME = '1980-01-01T00:00:00',
    @EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
 	@Agents					VARCHAR(MAX) = NULL,
	@DispositionCodes		VARCHAR(MAX) = NULL,
	@Origins				VARCHAR(MAX) = NULL,
	@MinDuration			INT = NULL,
	@MaxDuration			INT = NULL,
	@InteractionIds         VARCHAR(MAX) = NULL,
    @Evaluated              VARCHAR(MAX) = NULL,
	@UniqueIds				BIT = 0,							-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO
	@ResultType				VARCHAR(50) = NULL					-- VARIABLE PARA DETERMINAR SI LA BUSQUEDA SERA SOBRE SOBRE DETALLES O ID (DETAILED, SUMMARIZED)
    
)
AS
BEGIN
	-- INFO: EN CHAT SE CREAN UN ID EN CADA INTERACCION(EJM: CHATS DE ATENCION EN LAS WEB DE BANCOS), LOS DEMAS CANALES ID + ENDDATE
	
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL SP ES LLAMADO DEL SISTEMA O POR OTRO SP
	DECLARE @IS_NESTED BIT = 0

	-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = ''
	
	-- DECLARAMOS VARIABLES PARA NOS NOMBRES DE LAS TABLAS
	DECLARE @HISTORICAL_DATA_I6_BD NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_APPSTORE_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_CALL_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_CHAT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_FACEBOOK_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_INSTAGRAM_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_MAIL_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_TWITTER_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WEBCONTACT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WHATSAPP_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_YOUTUBE_TABLE NVARCHAR(100)

	-- DEFINIMOS EL NOMBRE DE LA BD
	SET @HISTORICAL_DATA_I6_BD = '[HistoricalDataI6_sq]' -- BD PARA DESARROLLO
	-- SET @HISTORICAL_DATA_I6_BD = '[HistoricalDataI6]'

	-- EL PARAMETRO TYPE DEFINE SI LA BD HISTORICALDATAI6 SE ENCUENTRA LOCAL O REMOTO
	IF (@Type = 0)  
	BEGIN  
		SET @HISTORICAL_DATA_I6_CALL_TABLE =			'[' + @Ip + ']' + '.' + @HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Call]'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @HISTORICAL_DATA_I6_CALL_TABLE =			@HISTORICAL_DATA_I6_BD + '.[dbo].[Detail_Call]'
	END  

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT += '
		SELECT '

	-- ARMAMOS LA PARTE BASE DE FILTROS
	SET @FILTERS_FIXED_PART = ' WHERE HDI6.[Vcc] = ''' + @VCC + ''''
	
	SET @FILTERS_OPTIONAL_PART  =' AND HDI6.[EndDate] BETWEEN '''
    SET @FILTERS_OPTIONAL_PART += (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) 
    SET @FILTERS_OPTIONAL_PART  +=''' AND '''  
    SET @FILTERS_OPTIONAL_PART  +=(SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' '
    

	-- DEPENDIENDO SI LA HORA DE FIN ES MAYOR A LA DE INICIO O NO DAMOS FORMA AL FILTRO DE HORA
	IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(HDI6.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
	IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(HDI6.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
	IF (@Campaigns IS NOT NULL AND @Campaigns != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Campaign] IN (SELECT VALUE FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	
	IF (@DispositionCodes IS NOT NULL AND @DispositionCodes != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND (
								(HDI6.[DispositionTreePath] IN (SELECT VALUE FROM [dbo].[split](''' + @DispositionCodes + ''','',''))) 
								OR
								(HDI6.[DispositionCode] IN (SELECT VALUE FROM [dbo].[split](''' + @DispositionCodes + ''','','')))
							)'

	-- ARMAMOS EL ORDER BY
	SET @SQL_EXTRA += 'ORDER BY [ID], [EndDate] DESC'

	IF (@InteractionType = 'CALL')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_CALL_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_CHAT
		SET @SQL_SELECT += '
								[Vcc]														''vcc'',
								[Id] + ''_0_0''												''ID'',
								[Id]														''InteractionId'',
								0															''Section'',
								0															''Part'',
								''CALL''													''Channel'',
								[ContactAddress]											''Number'', 
								''''														''Gender'',
								ISNULL([HoldTime], 0)										''SilenceTime'',
								ISNULL([AudioDuration], 0)									''DurationTime'', -- ESTO SE DEBE CORREGIR
								-- ISNULL([AttentionTime], 0)								''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN
								ISNULL([AudioDuration], [AttentionTime])					''AttentionTime'', -- SE AGREGO CAMPO PARA TOMAR EL TIEMPO TOTAL DE TODOS LOS PARTS
								ISNULL([AudioRecords], 1)									''TotalParts'',
								NULL														''Category1'',
								NULL														''Category2'',
								NULL														''Category3'',
								[DispositionTreePath]										''Description'',
								[DispositionCode]											''DispositionCode'',
								[Campaign]													''Campaign'',
								[LastAgent]													''Agent'',
								NULL														''agentName'',
								CASE [Initiative] WHEN ''INBOUND'' THEN ''E''
													WHEN ''Inb.'' THEN ''E''
													WHEN ''OUTBOUND'' THEN ''S''
													WHEN ''Out.'' THEN ''S''
													ELSE NULL END							''Type'',
								CONVERT(VARCHAR, [StartDate], 120)							''StartDate'',
								CONVERT(VARCHAR, [EndDate], 120)							''EndDate'',
								NULL														''Format'' '
								
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND [IsTaken] = 1 '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[LastAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND,Intb.')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND,Out.')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END

		IF(@MinDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[AudioDuration] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' '

		IF(@MaxDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[AudioDuration] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' '
	END 

	IF @InteractionIds IS NOT NULL AND @InteractionIds <> ''
    BEGIN
        SET @FILTERS_OPTIONAL_PART = '';
	    SET @FILTERS_EXCLUDING_PART=' AND ID IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
    END
	-- AGREGAMOS EL CONTADOR DE FILAR AL SELECT
	SET @SQL_SELECT += '
								,RN = ROW_NUMBER() OVER(PARTITION BY [ID], CONVERT(VARCHAR, EndDate, 23) ORDER BY [EndDate] DESC) '

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM ' + @HISTORICAL_DATA_I6_TABLE + ' HDI6 (NOLOCK) '

	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA
	
	-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
	IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
	BEGIN
		-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
		CREATE TABLE #TMP_HD_INTERACTIONS
		(
			[VCC] VARCHAR(50), 
			[ID] VARCHAR(300),  
			[InteractionId] VARCHAR(250), 
			[Section] INT,
			[Part] INT,
			[Channel] VARCHAR(50), 
			[Number] VARCHAR(50), 
			[Gender] VARCHAR(50), 
			[SilenceTime] DECIMAL(10, 2),
			[DurationTime] DECIMAL(10, 2),
			[AttentionTime] DECIMAL(10, 2),
			[TotalParts] INT,
			[Category1] VARCHAR(50),
			[Category2] VARCHAR(50),
			[Category3] VARCHAR(50),
			[Description] VARCHAR(50),
			[DispositionCode] VARCHAR(250), 
			[Campaign] VARCHAR(50), 
			[Agent] VARCHAR(50), 
			[AgentName] VARCHAR(250), 
			[Type] VARCHAR(50), 
			[StartDate] VARCHAR(100),
			[EndDate] VARCHAR(100),
			[Format] VARCHAR(50),
			RN INT
		)

		-- REAFIRMAMOS QUE EL SP NO ESTA ANIDADO EN OTRO
		SET @IS_NESTED = 0

		-- PRINT 'SP NO ANIDADO'
	END
	ELSE
	BEGIN
		-- SI LA TABLA TEMPORAL YA EXISTIA, EL SP ESTA ANIDADO EN OTRO (P.E.: [dbo].[GetAsyncBillingInteractions])
		SET @IS_NESTED = 1

		-- PRINT 'SP ANIDADO'
	END 

	-- INSERTAMOS EL RESULTADO EN LA TABLA TEMPORAL
	INSERT INTO #TMP_HD_INTERACTIONS
		-- EJECUTAMOS LA CONSULTA
		EXEC (@SQL_SELECT)

	-- VARIABLES PARA TRABAJAR CON LA TABLA TEMPORAL AL FINAL DEL SP
    DECLARE @QUERY                  VARCHAR(MAX) = ''
    DECLARE @QUERY_FILTER           VARCHAR(MAX) = ''
    DECLARE @QUERY_JOIN             VARCHAR(MAX) = ''
	
	-- FILTRO POR INTERACCIONES EVALUADAS O NO
	IF (@Evaluated IS NOT NULL AND @Evaluated <> '')
	    BEGIN 
		DECLARE @EvaluatedTable TABLE (Val BIT)

		INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')

		-- SOLAMENTE SI ES SI O NO
		IF ((SELECT COUNT(Val) FROM @EvaluatedTable) = 1 )
		BEGIN
			IF((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
			BEGIN 
				SET @QUERY_JOIN = ' JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[id] AND AEP.[Completed]=1 ) '
			END
		ELSE  --Si es No
           BEGIN
               SET @QUERY_JOIN = ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[id] AND AEP.[Completed]=1 ) '
               SET @QUERY_FILTER = ' AND AEP.[IdInteraction] IS NULL '
           END
       END
       
	 END
	-- FIN FILTRO INTERACCIONES EVALUADAS


	
	-- SI EL SP NO ESTA ANIDADO, HACEMOS SELECT AL RESULTADO A MOSTRAR
	IF @IS_NESTED = 0
	BEGIN
		-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
		IF @UniqueIds = 1 -- ENFOCADO A INTERACCIONES
		BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
				SET @QUERY = '
					SELECT HDI.[channel]										''interactionType'',
							COUNT(DISTINCT HDI.[id])							''interactions'',
							SUM(HDI.[totalParts])								''details'',
							SUM(HDI.[attentionTime])							''attentionTime''
						FROM #TMP_HD_INTERACTIONS HDI '
				SET @QUERY += @QUERY_JOIN
				SET @QUERY += ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER + ' GROUP BY HDI.[channel]'
				
			END
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
				SET @QUERY = ' SELECT HDI.* FROM #TMP_HD_INTERACTIONS HDI ' + @QUERY_JOIN +  ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER
				/*
				SET @QUERY = '
					SELECT HDI.[vcc]											''vcc'',
							HDI.[channel]										''interactionType'',
							HDI.[campaign]										''campaign'',
							HDI.[id]											''id'',
							HDI.[firstTakedAgent]								''agent'',
							HDI.[initiative]									''origin''
						FROM #TMP_HD_INTERACTIONS HDI '
				SET @QUERY += @QUERY_JOIN
				
				SET @QUERY += ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER + '
					GROUP BY HDI.[vcc], HDI.[channel], HDI.[campaign], HDI.[id], HDI.[firstTakedAgent], HDI.[initiative]'
				*/
			END
			--EJECUTAR CONSULTA
			EXEC (@QUERY)
			
		END
		ELSE -- ENFOCADO A DETALLES
		BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
			SET @QUERY = '
				SELECT HDI.[channel]											AS ''interactionType'',
						COUNT(DISTINCT HDI.[id])								AS ''interactions'',
						SUM(HDI.[totalParts])									AS ''details'',
						SUM(HDI.[attentionTime])							''attentionTime''
					FROM #TMP_HD_INTERACTIONS HDI '
			SET @QUERY += @QUERY_JOIN
			SET @QUERY += '	WHERE HDI.[RN] = 1 ' + @QUERY_FILTER + ' GROUP BY HDI.[channel] '
			
			END
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
			    SET @QUERY = ' SELECT HDI.* FROM #TMP_HD_INTERACTIONS HDI ' + @QUERY_JOIN +  ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER
			END 
		-- EJECUTAR CONSULTA
		  EXEC (@QUERY)
		END
	END
END
GO
PRINT N'Modificando [dbo].[GetProcessI6InteractionsToUpdate]...';


GO
 ALTER PROCEDURE [dbo].[GetProcessI6InteractionsToUpdate] (
	@VCC VARCHAR(50) = NULL, 
	@ProcessId VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	/*
	IF OBJECT_ID(N'tempdb..#I6_INTERACTIONS_TO_UPDATE') IS NOT NULL
	BEGIN
		DROP TABLE #I6_INTERACTIONS_TO_UPDATE
	END
	ELSE 
	BEGIN
		CREATE TABLE #I6_INTERACTIONS_TO_UPDATE(
			InteractionId VARCHAR(250)
		)
	END
	*/

	-- SELECCIONAMOS LOS ID DE INTERACIONES QUE TIENEN AUDIOS QUE REQUIEREN ACTUALIZACION DE I6
	-- INSERT INTO #I6_INTERACTIONS_TO_UPDATE
		SELECT PA.[VCC]								'vcc',
				PA.[ProcessId]						'processId',
				'CALL'								'interactionType',
				A.[ID]								'id',
				A.[NeedI6Update]					'needI6Update'
			FROM [dbo].[ProcessAudio] PA (NOLOCK)
			INNER JOIN [dbo].[Audio] A (NOLOCK)
				ON A.[VCC] = PA.[VCC]
					AND A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				AND A.[NeedI6Update] = 1
				AND (
					(
						ISNULL(A.[IsProcess], 0) = 0				
						AND 
						ISNULL(A.[IsTranscribed], 0) = 0
					)											-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
					OR 
					(
						A.[IsProcess] = 1						
						AND 
						A.[IsCancel] = 1
					)
				)												-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
			GROUP BY PA.[VCC], PA.[ProcessId], [A].[ID], A.[NeedI6Update]

	
	-- ACTUALIZAMOS LOS AUDIOS QUE SE VAN A TRABAJAR EN ESE PROCESS
	UPDATE A
		SET [IsProcess] = 1	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK)
			ON A.[VCC] = PA.[VCC]
				AND A.[ID] = PA.[AudioId]
				AND A.[Section] = PA.[Section]
				AND A.[Part] = PA.[Part]
		WHERE PA.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND A.[NeedI6Update] = 1
			AND (
				(
					ISNULL(A.[IsProcess], 0) = 0				
					AND 
					ISNULL(A.[IsTranscribed], 0) = 0
				)											-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR 
				(
					A.[IsProcess] = 1						
					AND 
					A.[IsCancel] = 1
				)
			)												-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
	
	-- SELECT * FROM [dbo].[ProcessAudio] PA (NOLOCK) WHERE [VCC] = 'incollege'
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcessInteractionsTask]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsTask]
(
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES SINCRONAS(CALL) Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR

		-- Actualiza en el primer momento que se consulta a estos registros, con el valor 1 en el campo IsProcess. Indica que se encuentra utilizado por un proceso.
		UPDATE [dbo].[Audio] SET
			[dbo].[Audio].[IsProcess] = 1,	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
			[dbo].[Audio].[IsCancel] = null, -- Limpiamos el campo isCancel para retomar los audios que fallaron en procesos pasados
			[dbo].[Audio].[ErrorMessage] = NULL
		
		-- Retornamos todas las columnas a listar.
		OUTPUT INSERTED.[VCC]							'vcc',
				PA.[ProcessId]							'processId',
				'CALL'									'interactionType',
				INSERTED.[ID]							'id',
				INSERTED.[Section]						'section',
				INSERTED.[Part]							'part',
				INSERTED.[StartDate]					'startDate',
				INSERTED.[EndDate]						'endDate',
				INSERTED.[Campaign]						'campaign',
				INSERTED.[DispositionCode]				'dispositionCode',
				INSERTED.[Agent]						'agent',
				INSERTED.[Type]							'origin',
				INSERTED.[RelativePath]					'relativePath',
				INSERTED.[FileName]						'fileName',
				INSERTED.[Format]                       'format',
				INSERTED.[MediaInfoTime]                'mediaInfoTime',
				INSERTED.[NeedI6Update]					'needI6Update',
				P.[Language]							'language',
				P.[DictionaryId]						'dictionaryId',
				E.[Name]								'name',
				E.[Type]								'environmentType',
				E.[Description]							'description',
				E.[FTPDirectory]						'ftpDirectory',
				E.[ApiHost]								'apiHost',
				E.[ApiPort]								'apiPort',
				E.[ApiUser]								'apiUser',
				E.[ApiPassword]							'apiPassword',
				E.[DbDisabled]							'dbDisabled',
				E.[DbServer]							'dbServer',
				E.[DbPort]								'dbPort',
				E.[DbUser]								'dbUser',
				E.[DbPassword]							'dbPassword',
				E.[PbxDisabled]							'pbxDisabled',
				E.[PbxServer]							'pbxServer',
				E.[PbxPort]								'pbxPort',
				E.[PbxUser]								'pbxUser',
				E.[PbxPassword]							'pbxPassword',
				INSERTED.[DurationTime]					'durationTime'
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK) 
			ON A.[VCC] = PA.[VCC]
				AND CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[VCC] = A.[VCC]
				AND PA.ProcessId = P.[Name]
		INNER JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = PA.[VCC]
				AND P.[Environment] = E.[Name]
		WHERE A.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND (
				(
					ISNULL(A.[IsProcess], 0) = 0				
					AND 
					ISNULL(A.[IsTranscribed], 0) = 0	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				)
				OR 
				(
					A.[IsProcess] = 1						
					AND 
					A.[IsCancel] = 1
				)
			)					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS

		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES ASINCRONAS Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR
		UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[IsProcess] = 1,
			[dbo].[AsyncInteraction].[IsCancel] = NULL,
			[dbo].[AsyncInteraction].[ErrorMessage] = NULL
		OUTPUT INSERTED.[VCC]														'vcc',
				P.[Name]															'processId',
				INSERTED.[Channel]													'interactionType',
				INSERTED.[ID]														'id',
				INSERTED.[EndDate]													'endDate',
				INSERTED.[Folder]													'folder',
				INSERTED.[Campaign]													'campaign',
				INSERTED.[DispositionCode]											'dispositionCode',
				ISNULL(INSERTED.[LastTakedAgent], INSERTED.[FirstTakedAgent])		'agent',
				INSERTED.[Initiative]												'origin',
				INSERTED.[TotalMessages]											'totalMessages',
				INSERTED.[RawChar]													'rawChar',
				INSERTED.[ExportedContent]											'exportedContent',
				P.[Language]														'language',
				INSERTED.[FileName]                                                 'fileName',
				'allegro'															'environmentType'
		FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[ID] = PAI.[InteractionId]
				AND AI.[EndDate] = PAI.[EndDate]
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[Name] = PAI.[ProcessId] 
		WHERE AI.[VCC] = @VCC
			AND PAI.[ProcessId] = @ProcessId
			AND (
				(
					ISNULL(AI.[IsProcess], 0) = 0
					AND 
					ISNULL(AI.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR 
				(
					AI.[IsProcess] = 1
					AND 
					AI.[IsCancel] = 1
				)
			)					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveI6InteractionAudio]...';


GO
ALTER PROCEDURE [dbo].[SaveI6InteractionAudio] (
	@VCC					VARCHAR(50) = NULL,
	@InteractionId			VARCHAR(250) = NULL,
	@OldSection				INT = NULL,
	@OldPart				INT = NULL,
	@NewSection				INT = NULL,
	@NewPart				INT = NULL,
	@AgentId				VARCHAR(50) = NULL,
	@Format					VARCHAR(10) = NULL
) AS 
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR UNA INTERACCION DE I6
	SET XACT_ABORT, NOCOUNT ON

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY

		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- DECLARAMOS UNA VARIABLE PARA AYUDAR A LA ACTUALIZACION
		DECLARE @NEED_I6_UPDATE BIT = 1
		DECLARE @AGENT_NAME VARCHAR(100) = NULL -- NOMBRE DEL AGENTE

		-- ASIGNAMOS EL VALOR ACTUALIZADO DEL FLAG
		SELECT @NEED_I6_UPDATE = A.[NeedI6Update]
			FROM [dbo].[Audio] A (NOLOCK)
			WHERE A.[VCC] = @VCC
				AND A.[ID] = @InteractionId
				AND A.[Section] = @OldSection
				AND A.[Part] = @OldPart

		-- EN CASO REQUIERAN ACTUALIZACION POR UNICA VEZ
		IF @NEED_I6_UPDATE = 1
		BEGIN
			-- ASIGNAMOS A LA VARIABLE EL NOMBRE DEL AGENTE
			SELECT @AGENT_NAME = A.[Name]
				FROM [dbo].[Agent] A (NOLOCK)
				WHERE A.[VCC] = @VCC
					AND A.[AgentId] = @AgentId

			-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA AUDIO
			UPDATE [dbo].[Audio] 
				SET [Section] = @NewSection,
					[Part] = @NewPart,
					[Agent] = @AgentId,
					[AgentName] = @AGENT_NAME,
					[Format] = @Format,
					[NeedI6Update] = 0,
					[IsProcess] = NULL
				WHERE [VCC] = @VCC
					AND [ID] = @InteractionId
					AND [Section] = @OldSection
					AND [Part] = @OldPart
					AND [NeedI6Update] = 1

			-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA PROCESSAUDIO
			UPDATE [dbo].[ProcessAudio]
				SET [Section] = @NewSection,
					[Part] = @NewPart
				WHERE [VCC] = @VCC
					AND [AudioId] = @InteractionId
					AND [Section] = @OldSection
					AND [Part] = @OldPart 
		END

		-- ACTUALIZAMOS EL SECTION Y PART EN LA INTERACCION EN LA TABLA INTERACTIONEVALUATIONPLAN
		UPDATE [dbo].[InteractionEvaluationPlan] 
			SET [InteractionSection] = @NewSection,
				[InteractionPart] = @NewPart,
				[IdAgent] = @AgentId,
				[AgentName] = @AGENT_NAME,
				[InteractionFormat] = @Format
			WHERE [Instance] = @VCC
				AND [IdInteraction] = @InteractionId
				AND [InteractionSection] = @OldSection
				AND [InteractionPart] = @OldPart 
			
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[BulkProcessI6Update]...';


GO
CREATE PROCEDURE [dbo].[BulkProcessI6Update]
AS
BEGIN
	-- ACTUALIZAMOS LOS AUDIOS CON EL RESULTADO EN LA TABLA
	UPDATE [dbo].[Audio] 
		SET [dbo].[Audio].[IsProcess] = NULL, 
			[dbo].[Audio].[Format] = [dbo].[#ProcessI6UpdateTemp].[Format],
			[dbo].[Audio].[IsTranscribed] = [dbo].[#ProcessI6UpdateTemp].[IsTranscribed],
			[dbo].[Audio].[IsCancel] = [dbo].[#ProcessI6UpdateTemp].[IsCancel],
			[dbo].[Audio].[ErrorMessage] = [dbo].[#ProcessI6UpdateTemp].[ErrorMessage],
			[dbo].[Audio].[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[#ProcessI6UpdateTemp]
		WHERE [dbo].[Audio].[VCC] = [dbo].[#ProcessI6UpdateTemp].[VCC]
			AND [dbo].[Audio].[ID] = [dbo].[#ProcessI6UpdateTemp].[ID]
			AND [dbo].[Audio].[Section] = [dbo].[#ProcessI6UpdateTemp].[Section]
			AND [dbo].[Audio].[Part] = [dbo].[#ProcessI6UpdateTemp].[Part]
			AND [dbo].[#ProcessI6UpdateTemp].[Channel] = 'CALL'
			AND [dbo].[Audio].[NeedI6Update] = 1
			AND [dbo].[Audio].[IsProcess] = 1
			AND [dbo].[Audio].[IsCancel] IS NULL 
			AND [dbo].[Audio].[IsTranscribed] IS NULL

	DROP TABLE [dbo].[#ProcessI6UpdateTemp]
END
GO
PRINT N'Actualización completada.';


GO
